unit Unit1;
interface
uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWCompButton,
  IWCompLabel, Vcl.Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl,
  IWControl, IWCompEdit;

type
  TOperator = (opEquals, opAdd, opSubtract, opMultiply, opDivide);

  TIWForm1 = class(TIWAppForm)
    IWEditX: TIWEdit;
    IWLabelAnswer: TIWLabel;
    IWButtonAdd: TIWButton;
    IWButtonSubtract: TIWButton;
    IWButtonMultiply: TIWButton;
    IWButtonDivide: TIWButton;
    IWButtonEquals: TIWButton;
    IWButtonClear: TIWButton;
    procedure IWButtonAddAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure IWButtonSubtractAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure IWButtonMultiplyAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure IWButtonDivideAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure IWButtonEqualsAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure IWButtonClearClick(Sender: TObject);
  private
    ActiveOperator: TOperator;
    procedure CalculateResult(NewOperator: TOperator);
  end;

implementation

{$R *.dfm}

procedure TIWForm1.IWButtonClearClick(Sender: TObject);
begin
  IWLabelAnswer.Caption := '0';
  IWEditX.Text := '0';
  ActiveOperator := opEquals;
end;

procedure TIWForm1.CalculateResult(NewOperator: TOperator);
var
  X,Y: Integer;
begin
  X := StrToIntDef(IWEditX.Text,0);
  Y := StrToIntDef(IWLabelAnswer.Caption,0);
  try
    case ActiveOperator of
           opAdd: Y := Y + X;
      opSubtract: Y := Y - X;
      opMultiply: Y := Y * X;
        opDivide: Y := Y div X;
      else Y := X;
    end;
    IWLabelAnswer.Caption := Y.ToString
  except
    on E: Exception do
      IWLabelAnswer.Caption := E.Message
  end;
  ActiveOperator := NewOperator;
end;

procedure TIWForm1.IWButtonAddAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  CalculateResult(opAdd);
end;

procedure TIWForm1.IWButtonSubtractAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  CalculateResult(opSubtract);
end;

procedure TIWForm1.IWButtonMultiplyAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  CalculateResult(opMultiply);
end;

procedure TIWForm1.IWButtonDivideAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  CalculateResult(opDivide);
end;

procedure TIWForm1.IWButtonEqualsAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  CalculateResult(ActiveOperator); // repeat previous operation
end;


initialization
  TIWForm1.SetAsMainForm;

end.
