unit TestForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Winapi.WebView2, Winapi.ActiveX,
  Vcl.Edge, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TFormWebTest = class(TForm)
    Panel1: TPanel;
    cbURL: TComboBox;
    Button1: TButton;
    EdgeBrowser1: TEdgeBrowser;
    procedure Button1Click(Sender: TObject);
    procedure EdgeBrowser1NavigationCompleted(Sender: TCustomEdgeBrowser;
      IsSuccess: Boolean; WebErrorStatus: TOleEnum);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure IWEditValue(EdgeBrowser: TEdgeBrowser; const Name,Value: String);
    procedure IWButtonClick(EdgeBrowser: TEdgeBrowser; const Name: String);
  end;

var
  FormWebTest: TFormWebTest;

implementation
uses
  CodeSiteLogging;

{$R *.dfm}

procedure TFormWebTest.Button1Click(Sender: TObject);
begin
  EdgeBrowser1.Navigate(cbURL.Text);
  Tag := 0;
end;

procedure TFormWebTest.IWButtonClick(EdgeBrowser: TEdgeBrowser; const Name: String);
begin
  CodeSite.Send('$(''#' + Name + ''').trigger(''click'');');
  EdgeBrowser.ExecuteScript('$(''#' + Name + ''').trigger(''click'');');
end;

procedure TFormWebTest.IWEditValue(EdgeBrowser: TEdgeBrowser; const Name, Value: String);
begin
  CodeSite.Send(Name +  '.value = '''+ Value + ''';');
  EdgeBrowser.ExecuteScript(Name + '.value = ''' + Value + ''';');
  CodeSite.Send('$(''#' + Name + ''').trigger(''change'');');
  EdgeBrowser.ExecuteScript('$(''#' + Name + ''').trigger(''change'');');
end;


procedure TFormWebTest.EdgeBrowser1NavigationCompleted(Sender: TCustomEdgeBrowser; IsSuccess: Boolean; WebErrorStatus: TOleEnum);
begin
  CodeSite.Send('EdgeBrowser1NavigationCompleted #' + Tag.ToString);
  case Tag of
    0: Tag := Tag + 1;
    1: begin
         Sleep(500);
         IWEditValue(EdgeBrowser1, 'IWEDITX', '42');
         Tag := Tag + 1;
         Sleep(500);
         IWButtonCLick(EdgeBrowser1, 'IWBUTTONDIVIDE');
         Tag := Tag + 1;
         Sleep(500);
         IWEditValue(EdgeBrowser1, 'IWEDITX', '3');
         Tag := Tag + 1;
         IWButtonCLick(EdgeBrowser1, 'IWBUTTONEQUALS');
         Tag := Tag + 1;
       end;
  end;
end;

end.
